Summary:	JavaScript interpreter and libraries
Name:		mozjs24
Version:	24.2.0
Release:	11%{?dist}
License:	MPLv2.0
Group:		Development/Languages
URL:		http://www.mozilla.org/js/
Source0:	http://ftp.mozilla.org/pub/mozilla.org/js/mozjs-%{version}.tar.bz2
BuildRequires:	pkgconfig(nspr)
BuildRequires:	readline-devel
BuildRequires:	/usr/bin/zip
BuildRequires:	/usr/bin/python
BuildRequires:	perl(Getopt::Long)

Patch0:		js17-build-fixes.patch
Patch1:		mozjs24-0001-Add-AArch64-support.patch
Patch2:		mozjs24-hardening-flags.patch
Patch3:		mozjs24-perl522.patch
Patch4:		mozjs24-48-bit-VA-fix.patch

%description
JavaScript is the Netscape-developed object scripting language used in millions
of web pages and server applications worldwide. Netscape's JavaScript is a
super set of the ECMA-262 Edition 3 (ECMAScript) standard scripting language,
with only mild differences from the published standard.

%package devel
Summary: Header files, libraries and development documentation for %{name}
Group: Development/Libraries
Requires: %{name}%{?_isa} = %{version}-%{release}

%description devel
This package contains the header files, static libraries and development
documentation for %{name}. If you like to develop programs using %{name},
you will need to install %{name}-devel.

%prep
%setup -q -n mozjs-%{version}
# Delete bundled sources
rm js/src/editline -rf
rm js/src/ctypes/libffi -rf
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
chmod a+x configure

%build
%configure \
  --disable-static \
  --with-system-nspr \
  --enable-threadsafe \
  --enable-readline \
%ifarch %{arm}
  --disable-yarr-jit \
  --disable-ion \
%endif
  --enable-xterm-updates
make %{?_smp_mflags}

%install
make install DESTDIR=%{buildroot}
# For some reason the headers and pkg-config file are executable
find %{buildroot}%{_includedir} -type f -exec chmod a-x {} \;
chmod a-x  %{buildroot}%{_libdir}/pkgconfig/*.pc
# Upstream does not honor --disable-static yet
rm -f %{buildroot}%{_libdir}/*.a
# This is also statically linked; once that is fixed that we could
# consider shipping it.
rm -f %{buildroot}%{_bindir}/js24

# However, delete js-config since everything should use
# the pkg-config file.
rm -f %{buildroot}%{_bindir}/js24-config

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%doc LICENSE README
%{_libdir}/*.so

%files devel
%{_libdir}/pkgconfig/*.pc
%{_includedir}/mozjs-24

%changelog
* Wed Sep 21 2016 Peter Robinson <pbrobinson@fedoraproject.org> 24.2.0-11
- Disable JIT on ARMv7 (fixes rhbz #1378054)

* Mon Sep 12 2016 Debarshi Ray <rishi@fedoraproject.org> 24.2.0-10
- Backport fix for 48-bit VA on Aarch64 (RH #1375305)

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 24.2.0-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Mon Nov 09 2015 Yaakov Selkowitz <yselkowi@redhat.com> - 24.2.0-8
- Specify perl module dependencies for F24

* Mon Nov 09 2015 Yaakov Selkowitz <yselkowi@redhat.com> - 24.2.0-7
- Fix build with hardening flags, Perl 5.22 (#1239699)

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 24.2.0-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sun Aug 17 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 24.2.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 24.2.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Wed Jan 22 2014 Peter Robinson <pbrobinson@fedoraproject.org> 24.2.0-3
- Add patch to fix FTBFS on aarch64

* Fri Jan 10 2014 Debarshi Ray <rishi@fedoraproject.org> 24.2.0-2
- Fix a spelling mistake

* Thu Jan 09 2014 Debarshi Ray <rishi@fedoraproject.org> 24.2.0-1
- Initial spec
